// db3View.cpp : implementation of the CDb3View class
//

#include "stdafx.h"
#include "db3.h"

#include "db3Set.h"
#include "db3Doc.h"
#include "db3View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDb3View

IMPLEMENT_DYNCREATE(CDb3View, CRecordView)

BEGIN_MESSAGE_MAP(CDb3View, CRecordView)
	//{{AFX_MSG_MAP(CDb3View)
	ON_BN_CLICKED(IDC_BUTTON1, OnInserisci)
	ON_BN_CLICKED(IDC_BUTTON2, OnModifica)
	ON_BN_CLICKED(IDC_BUTTON3, OnElimina)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRecordView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDb3View construction/destruction

CDb3View::CDb3View()
	: CRecordView(CDb3View::IDD)
{
	//{{AFX_DATA_INIT(CDb3View)
	m_pSet = NULL;
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CDb3View::~CDb3View()
{
}

void CDb3View::DoDataExchange(CDataExchange* pDX)
{
	CRecordView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDb3View)
	DDX_Control(pDX, IDC_BUTTON3, m_Elimina);
	DDX_Control(pDX, IDC_BUTTON2, m_Modifica);
	DDX_Control(pDX, IDC_BUTTON1, m_Inserisci);
	DDX_FieldText(pDX, IDC_EDIT1, m_pSet->m_DescP, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT2, m_pSet->m_Prezzo, m_pSet);
	DDX_FieldText(pDX, IDC_EDIT3, m_pSet->m_CProd, m_pSet);
	//}}AFX_DATA_MAP
}

BOOL CDb3View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRecordView::PreCreateWindow(cs);
}

void CDb3View::OnInitialUpdate()
{
	m_pSet = &GetDocument()->m_db3Set;
	CRecordView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CDb3View printing

BOOL CDb3View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDb3View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDb3View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDb3View diagnostics

#ifdef _DEBUG
void CDb3View::AssertValid() const
{
	CRecordView::AssertValid();
}

void CDb3View::Dump(CDumpContext& dc) const
{
	CRecordView::Dump(dc);
}

CDb3Doc* CDb3View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDb3Doc)));
	return (CDb3Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDb3View database support
CRecordset* CDb3View::OnGetRecordset()
{
	return m_pSet;
}


/////////////////////////////////////////////////////////////////////////////
// CDb3View message handlers

void CDb3View::OnInserisci() 
{

	/*
	m_pSet ->AddNew();
//m_pSet ->Fields->GetItem("CProd")->Value = m_Codice;
//m_pSet ->GetFieldValue(55,"CProd") =  m_pSet->m_CProd;
CDBVariant x;
m_pSet ->GetFieldValue("DescP", x) = m_pSet->m_DescP;

//m_pSet ->
//m_pSet ->AddNew();

*/
char Codice[4];	
char Descrizione[30];
char Prezzo[5];

	::CoInitialize(NULL);

	_ConnectionPtr PuntConn;
	PuntConn.CreateInstance(__uuidof(Connection));
try	 {
 	PuntConn->Open("DBNegozio","","",NULL);
}	catch(_com_error &e) { 
//cout << "eccezione";
}


	UpdateData(true);

    _bstr_t strCodice = (_bstr_t) m_pSet->m_CProd;
	_bstr_t strDescrizione = (_bstr_t) m_pSet->m_DescP;
	_bstr_t strPrezzo = (_bstr_t) m_pSet->m_Prezzo;

	//UpdateData(false);

 _bstr_t StrQuery = "Insert INTO Prodotti (CProd, DescP, Prezzo) values ( "+ strCodice + ", '" + strDescrizione + "'," + strPrezzo + ")"; 
MessageBox( StrQuery, MB_OK);


PuntConn->Execute( StrQuery , NULL, adExecuteNoRecords);

MessageBox( "Prodotto inserito", "Attenzione",  MB_OK | MB_ICONEXCLAMATION);

	PuntConn->Close();
	CoUninitialize();

}

void CDb3View::OnModifica() 
{
char Codice[4];	
char Descrizione[30];
char Prezzo[5];

	::CoInitialize(NULL);

	_ConnectionPtr PuntConn;
	PuntConn.CreateInstance(__uuidof(Connection));
try	 {
 	PuntConn->Open("DBNegozio","","",NULL);
}	catch(_com_error &e) { 
//cout << "eccezione";
}


	UpdateData(true);

    _bstr_t strCodice = (_bstr_t) m_pSet->m_CProd;
	_bstr_t strDescrizione = (_bstr_t) m_pSet->m_DescP;
	_bstr_t strPrezzo = (_bstr_t) m_pSet->m_Prezzo;

	//UpdateData(false);

 _bstr_t StrQuery = "Update Prodotti SET DescP = '" + strDescrizione + "', Prezzo = " + strPrezzo + " WHERE CProd = " + strCodice ; 
MessageBox( StrQuery, MB_OK);


PuntConn->Execute( StrQuery , NULL, adExecuteNoRecords);

MessageBox( "Prodotto modificato", "Attenzione", MB_OK | MB_ICONEXCLAMATION);

	PuntConn->Close();
	CoUninitialize();
	
}

void CDb3View::OnElimina() 
{
char Codice[4];	
char Descrizione[30];
char Prezzo[5];

	::CoInitialize(NULL);

	_ConnectionPtr PuntConn;
	PuntConn.CreateInstance(__uuidof(Connection));
try	 {
 	PuntConn->Open("DBNegozio","","",NULL);
}	catch(_com_error &e) { 
//cout << "eccezione";
}


	UpdateData(true);

    _bstr_t strCodice = (_bstr_t) m_pSet->m_CProd;
	_bstr_t strDescrizione = (_bstr_t) m_pSet->m_DescP;
	_bstr_t strPrezzo = (_bstr_t) m_pSet->m_Prezzo;

	//UpdateData(false);

 _bstr_t StrQuery = "Delete From Prodotti WHERE CProd = " + strCodice ; 
MessageBox( StrQuery, MB_OK);


PuntConn->Execute( StrQuery , NULL, adExecuteNoRecords);

MessageBox( "Prodotto eliminato", "Attenzione", MB_OK | MB_ICONEXCLAMATION);

	PuntConn->Close();
	CoUninitialize();
	
}
