// db3Set.cpp : implementation of the CDb3Set class
//

#include "stdafx.h"
#include "db3.h"
#include "db3Set.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDb3Set implementation

IMPLEMENT_DYNAMIC(CDb3Set, CRecordset)

CDb3Set::CDb3Set(CDatabase* pdb)
	: CRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CDb3Set)
	m_CProd = 0;
	m_Cat = 0;
	m_DescP = _T("");
	m_Prezzo = 0;
	m_QtaRes = 0;
	m_nFields = 5;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dynaset;
}

CString CDb3Set::GetDefaultConnect()
{
	return _T("ODBC;DSN=Database di Microsoft Access");
}

CString CDb3Set::GetDefaultSQL()
{
	return _T("[Prodotti]");
}

void CDb3Set::DoFieldExchange(CFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CDb3Set)
	pFX->SetFieldType(CFieldExchange::outputColumn);
	RFX_Long(pFX, _T("[CProd]"), m_CProd);
	RFX_Long(pFX, _T("[Cat]"), m_Cat);
	RFX_Text(pFX, _T("[DescP]"), m_DescP);
	RFX_Long(pFX, _T("[Prezzo]"), m_Prezzo);
	RFX_Long(pFX, _T("[QtaRes]"), m_QtaRes);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CDb3Set diagnostics

#ifdef _DEBUG
void CDb3Set::AssertValid() const
{
	CRecordset::AssertValid();
}

void CDb3Set::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG
